//
//	test the cal rawx2mm calls
//
#include <fstream>
#include <iostream>
#include "CalServer.h"
#include "Xmm.h"
#include "GeometryDataServer.h"
#include "common.h"

using namespace std;

int main()
{
	const XmmInstrument &ins = xmmPayLoad.rgs1;

	calServer.setInstrument(ins.id());
	calServer.state()->randomize()->set(false);
	calServer.state()->ccd()->set(9);
	calServer.state()->ocb()->set(1);

	unsigned nY = ins.maxY()-ins.minY()+1;
	CalInt16Vector rawXVec(0, nY),
				   rawYVec(0, nY);
	for (unsigned n=1; n<=nY; ++n) {
		rawXVec[n-1] = ins.minX();
		rawYVec[n-1] = n;
	}

	GeometryDataServer *cdf = calServer.getAtom(cdf);
	XmmPixelList pl = cdf->chipCoordList(rawXVec, rawYVec);
	XmmCartesianPointList cpl =	pl.toCamCoord1().toCamCoord2().toSacCoord();
	XmmRowlandPointList rpl = cpl.toRowCoord();

	for (unsigned n=0; n<nY; ++n)
		cout<<setprecision(14)<<rpl.beta()[n]<<' '<<rpl.chi()[n]<<endl;

	return 0;
}
